scala.util.hashing

# MurmurHash3

###
Related Doc: package hashing

#### object MurmurHash3 extends MurmurHash3

An implementation of Austin Appleby's MurmurHash 3 algorithm (MurmurHash3_x86_32). This object contains methods that hash values of various types as well as means to construct `Hashing` objects.

This algorithm is designed to generate well-distributed non-cryptographic hashes. It is designed to hash data in 32 bit chunks (ints).

The mix method needs to be called at each step to update the intermediate hash value. For the last chunk to incorporate into the hash mixLast may be used instead, which is slightly faster. Finally finalizeHash needs to be called to compute the final hash value.

This is based on the earlier MurmurHash3 code by Rex Kerr, but the MurmurHash3 algorithm was since changed by its creator Austin Appleby to remedy some weaknesses and improve performance. This represents the latest and supposedly final version of the algortihm (revision 136).

Source
  MurmurHash3.scala
See also

  http://code.google.com/p/smhasher

Linear Supertypes
MurmurHash3, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MurmurHash3
2. MurmurHash3
3. AnyRef
4. Any

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### class ArrayHashing[T] extends Hashing[Array[T]]

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### def arrayHash[T](a: Array[T]): Int

5. #### final def arrayHash[T](a: Array[T], seed: Int): Int

   Compute the hash of an array.

   Compute the hash of an array.

   Definition Classes
     MurmurHash3

6. #### def arrayHashing[T]: ArrayHashing[T]

7. #### final val arraySeed: Int(1007110753)

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def bytesHash(data: Array[Byte]): Int

10. #### final def bytesHash(data: Array[Byte], seed: Int): Int

    Compute the hash of a byte array.

    Compute the hash of a byte array. Faster than arrayHash, because it hashes 4 bytes at once.

    Definition Classes
      MurmurHash3

11. #### def bytesHashing: Hashing[Array[Byte]]

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

14. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

15. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

16. #### final def finalizeHash(hash: Int, length: Int): Int

    Finalize a hash to incorporate the length and make sure all bits avalanche.

    Finalize a hash to incorporate the length and make sure all bits avalanche.

    Definition Classes
      MurmurHash3

17. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

18. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

19. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

20. #### final def listHash(xs: collection.immutable.List[_], seed: Int): Int

    Definition Classes
      MurmurHash3

21. #### def mapHash(xs: Map[_, _]): Int

22. #### final val mapSeed: Int

23. #### final def mix(hash: Int, data: Int): Int

    Mix in a block of data into an intermediate hash value.

    Mix in a block of data into an intermediate hash value.

    Definition Classes
      MurmurHash3

24. #### final def mixLast(hash: Int, data: Int): Int

    May optionally be used as the last mixing step.

    May optionally be used as the last mixing step. Is a little bit faster than mix, as it does no further mixing of the resulting hash. For the last element this is not necessary as the hash is thoroughly mixed during finalization anyway.

    Definition Classes
      MurmurHash3

25. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

26. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

27. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

28. #### def orderedHash(xs: TraversableOnce[Any]): Int

29. #### final def orderedHash(xs: TraversableOnce[Any], seed: Int): Int

    Compute a hash that depends on the order of its arguments.

    Compute a hash that depends on the order of its arguments.

    Definition Classes
      MurmurHash3

30. #### def orderedHashing: Hashing[TraversableOnce[Any]]

31. #### def productHash(x: Product): Int

32. #### final def productHash(x: Product, seed: Int): Int

    Compute the hash of a product

    Compute the hash of a product

    Definition Classes
      MurmurHash3

33. #### def productHashing: Hashing[Product]

34. #### final val productSeed: Int(-889275714)

35. #### def seqHash(xs: collection.Seq[_]): Int

    To offer some potential for optimization.

36. #### final val seqSeed: Int

37. #### def setHash(xs: Set[_]): Int

38. #### final val setSeed: Int

39. #### def stringHash(x: String): Int

40. #### final def stringHash(str: String, seed: Int): Int

    Compute the hash of a string

    Compute the hash of a string

    Definition Classes
      MurmurHash3

41. #### def stringHashing: Hashing[String]

42. #### final val stringSeed: Int(-137723950)

43. #### final val symmetricSeed: Int(-1248659538)

44. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

45. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

46. #### final val traversableSeed: Int(-415593707)

47. #### def unorderedHash(xs: TraversableOnce[Any]): Int

48. #### final def unorderedHash(xs: TraversableOnce[Any], seed: Int): Int

    Compute a hash that is symmetric in its arguments - that is a hash where the order of appearance of elements does not matter.

    Compute a hash that is symmetric in its arguments - that is a hash where the order of appearance of elements does not matter. This is useful for hashing sets, for example.

    Definition Classes
      MurmurHash3

49. #### def unorderedHashing: Hashing[TraversableOnce[Any]]

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from MurmurHash3

### Inherited from AnyRef

### Inherited from Any

### Ungrouped